
dofile("lua/axistobinary.lua")
dofile("lua/povtobinary.lua")

OnBinaryEventOn = {}
OnBinaryEventOff = {}

function TriggerBinaryEventOn(event)
  if OnBinaryEventOnReciever ~= nil then
    OnBinaryEventOnReciever(event)
  elseif OnBinaryEventOn[event] ~= nil then
    OnBinaryEventOn[event]()
  end
end

function TriggerBinaryEventOff(event)
  if OnBinaryEventOffReciever ~= nil then
    OnBinaryEventOffReciever(event)
  elseif OnBinaryEventOff[event] ~= nil then
    OnBinaryEventOff[event]()
  end
end

function KeyPressed(key)
  TriggerBinaryEventOn(key)
  --sys.DebugOutput("key "..key)
end

function KeyReleased(key)
  TriggerBinaryEventOff(key)
end

MouseStartX = 0
MouseStartY = 0
MouseStopX = 0
MouseStopY = 0
DragActive = false

function MouseButtonPressed(ButtonId,PosAbsX,PosAbsY,PosRelX,PosRelY,PosRollAbs,PosRollRel)
  MouseStartX = PosAbsX
  MouseStartY = PosAbsY
  DragActive = true
end

function MouseButtonReleased(ButtonId,PosAbsX,PosAbsY,PosRelX,PosRelY,PosRollAbs,PosRollRel)
  MouseStopX = PosAbsX
  MouseStopY = PosAbsY
  sys.DebugOutput("X: "..MouseStartX.." "..MouseStopX.." Y: "..MouseStartY.." "..MouseStopY)
  if MouseStopX - MouseStartX > 1 and MouseStopY - MouseStartY > 1 then
    local startx = (MouseStartX / Globals["WindowWidth"])
    local starty = 1.0 - (MouseStartY / Globals["WindowHeight"])
    local stopx = (MouseStopX / Globals["WindowWidth"])
    local stopy = 1.0 - (MouseStopY / Globals["WindowHeight"])
    local diffx = stopx - startx
    local diffy = starty - stopy
    if diffx > diffy then
      stopy = starty - diffx
    else
      stopx = startx + diffy
    end
    startx = startx * (m_stop.x - m_start.x) + m_start.x
    starty = starty * (m_stop.y - m_start.y) + m_start.y
    stopx = stopx * (m_stop.x - m_start.x) + m_start.x
    stopy = stopy * (m_stop.y - m_start.y) + m_start.y

    m_start.x = startx
    m_start.y = starty
    m_stop.x = stopx
    m_stop.y = stopy
    --sys.DebugOutput("startx "..startx.." starty "..starty.."\nstopx "..stopx.." stopy "..stopy)
    m_recompute = true
    UpdateGui()
  end
  DrawRahmen = false
  DragActive = false
end

function MouseMoved(PosAbsX,PosAbsY,PosRelX,PosRelY,PosRollAbs,PosRollRel)
  if not DragActive then return end
  MouseStopX = PosAbsX
  MouseStopY = PosAbsY
  if MouseStopX - MouseStartX > 1 and MouseStopY - MouseStartY > 1 then
    local startx = (MouseStartX / Globals["WindowWidth"])
    local starty = 1.0 - (MouseStartY / Globals["WindowHeight"])
    local stopx = (MouseStopX / Globals["WindowWidth"])
    local stopy = 1.0 - (MouseStopY / Globals["WindowHeight"])
    local diffx = stopx - startx
    local diffy = starty - stopy
    if diffx > diffy then
      stopy = starty - diffx
    else
      stopx = startx + diffy
    end
    renderer.VertexBufferResetLocalData(Rahmen)
    renderer.VertexBufferAddData(Rahmen,vec2(startx,starty))
    renderer.VertexBufferAddData(Rahmen,vec2(stopx,starty))

    renderer.VertexBufferAddData(Rahmen,vec2(stopx,starty))
    renderer.VertexBufferAddData(Rahmen,vec2(stopx,stopy))

    renderer.VertexBufferAddData(Rahmen,vec2(stopx,stopy))
    renderer.VertexBufferAddData(Rahmen,vec2(startx,stopy))

    renderer.VertexBufferAddData(Rahmen,vec2(startx,stopy))
    renderer.VertexBufferAddData(Rahmen,vec2(startx,starty))

    renderer.VertexBufferUpdate(Rahmen)
    DrawRahmen = true
  end
end

function ControllerButtonPressed(ControlerId,ButtonId)
  local key = "C"..ControlerId.."B"..ButtonId
  --io.write("Pressed "..key.."\n")
  TriggerBinaryEventOn(key)
end

function ControllerButtonReleased(ControlerId,ButtonId)
  local key = "C"..ControlerId.."B"..ButtonId
  --io.write("Released "..key.."\n")
  TriggerBinaryEventOff(key)
end

InputControler = {}

function ControllerAxisMoved(ControlerId,AxisId,AxisValue)
  local key = "C"..ControlerId.."A"..AxisId
  --io.write("Moved "..key.." Value "..AxisValue.."\n")
  if InputControler[ControlerId] == nil then
    InputControler[ControlerId] = {}
  end
  if InputControler[ControlerId]._Axis == nil then
    InputControler[ControlerId]._Axis = {}
  end
  if InputControler[ControlerId]._Axis[AxisId] == nil then
    InputControler[ControlerId]._Axis[AxisId] = AxisToBinary.Create(10000,key)
  end
  InputControler[ControlerId]._Axis[AxisId](AxisValue)
end

function ControllerPovMoved(ControlerId,PovId,PovDirection)
  --local key = "C"..ControlerId.."P"..PovId.."D"..PovDirection
  --io.write("Pressed "..key.."\n")
  if InputControler[ControlerId] == nil then
    InputControler[ControlerId] = {}
  end
  if InputControler[ControlerId]._Pov == nil then
    InputControler[ControlerId]._Pov = {}
  end
  if InputControler[ControlerId]._Pov[PovId] == nil then
    local key = "C"..ControlerId.."P"..PovId.."D"
    InputControler[ControlerId]._Pov[PovId] = PovToBinary.Create(key)
  end
  InputControler[ControlerId]._Pov[PovId](PovDirection)
end

function ControllerVec3Moved(ControlerId,Vec3Id, ValueX, ValueY, ValueZ)
end
