RepeatEvent = {}

RepeatEvent.Metatable = {}
RepeatEvent.ActivatorMetatable = {}
RepeatEvent.DeactivatorMetatable = {}
RepeatEvent.FunctionTable = {}
RepeatEvent.Events = {}
RepeatEvent.EventsSize = 0

function RepeatEvent.Create(Time,Function)
  local new = {}
  new.Time = Time
  new.Last = 0
  new.Active = false
  new.Function = Function;
  RepeatEvent.EventsSize = RepeatEvent.EventsSize + 1
  new.Index = RepeatEvent.EventsSize
  setmetatable(new,RepeatEvent.Metatable)
  RepeatEvent.Events[RepeatEvent.EventsSize] = new
  return new
end

function RepeatEvent.FunctionTable.Activate(Event)
  Event.Last = 0
  Event.Active = true
  Event.Function()
end

function RepeatEvent.FunctionTable.Deactivate(Event)
  Event.Active = false
end

function RepeatEvent.FunctionTable.Repeat(Event,TimeDiff)
  if Event.Active then
    Event.Last = Event.Last + TimeDiff
  end

  while Event.Last > Event.Time do
    Event.Function()
    Event.Last = Event.Last - Event.Time
  end
end

function RepeatEvent.FunctionTable.GetActivator(Event)
  local new = {}
  new.Event = Event
  setmetatable(new,RepeatEvent.ActivatorMetatable)
  return new
end

function RepeatEvent.FunctionTable.GetDeactivator(Event)
  local new = {}
  new.Event = Event
  setmetatable(new,RepeatEvent.DeactivatorMetatable)
  return new
end

function RepeatEvent.ActivatorCall(obj)
  obj.Event:Activate()
end

function RepeatEvent.DeactivatorCall(obj)
  obj.Event:Deactivate()
end

function RepeatEvent.Repeat(TimeDiff)
  if RepeatEvent.EventsSize > 0 then
    for i=1,RepeatEvent.EventsSize do
      if RepeatEvent.Events[i] ~= nil then
        RepeatEvent.Events[i]:Repeat(TimeDiff)
      end
    end
  end
end

RepeatEvent.Metatable["__index"] = RepeatEvent.FunctionTable;

RepeatEvent.ActivatorMetatable["__call"] = RepeatEvent.ActivatorCall;
RepeatEvent.DeactivatorMetatable["__call"] = RepeatEvent.DeactivatorCall;
